diff --git a/gnu/packages/icu4c.scm b/gnu/packages/icu4c.scm
index 1e4f66d956..05911addcd 100644
--- a/gnu/packages/icu4c.scm
+++ b/gnu/packages/icu4c.scm
@@ -27,14 +27,17 @@
 
 (define-module (gnu packages icu4c)
   #:use-module (gnu packages)
+  #:use-module (gnu packages cpio)
   #:use-module (gnu packages java)
   #:use-module (gnu packages perl)
+  #:use-module (gnu packages pkg-config)
   #:use-module (gnu packages python)
   #:use-module (guix gexp)
   #:use-module (guix licenses)
   #:use-module (guix packages)
   #:use-module (guix utils)
   #:use-module (guix download)
+  #:use-module (guix git-download)
   #:use-module (guix build-system ant)
   #:use-module (guix build-system gnu))
 
@@ -243,3 +246,99 @@ (define-public java-icu4j
 globalisation support for software applications.  This package contains the
 Java part.")
     (license x11)))
+
+(define-public icu4c-for-skia
+  (let ((commit "a0718d4f121727e30b8d52c7a189ebf5ab52421f")
+        (revision "0"))
+    (package
+      (inherit icu4c)
+      (name "icu4c-for-skia")
+      (version "skia")
+      (source
+       (origin
+         (method git-fetch)
+         (uri (git-reference
+               (url "https://chromium.googlesource.com/chromium/deps/icu.git")
+               (commit commit)))
+         (file-name (git-file-name name version))
+         (sha256
+          (base32 "1qxws2p91f6dmhy7d3967r5ygz06r88pkmpm97px067x0zzdz384"))))
+      (native-inputs (list python cpio pkg-config))
+      (arguments
+       (list
+        #:make-flags #~`(,(string-append "DESTDIR=" #$output))
+        #:configure-flags #~'(;;"--enable-shared=no" "--enable-static=yes"
+                              "--prefix=" "--exec-prefix=")
+        #:phases
+        #~(modify-phases %standard-phases
+            (add-after 'unpack 'chdir-to-source
+              (lambda _ (chdir "source")))
+            (replace 'configure
+              (lambda* (#:key inputs parallel-build? configure-flags #:allow-other-keys)
+                (let ((bash (search-input-file inputs "/bin/sh")))
+                  ;; Replace bash executable.
+                  (setenv "CONFIG_SHELL" bash)
+                  (substitute* "./configure"
+                    (("`/bin/sh")
+                     (string-append "`" bash)))
+                  ;; Make the static library position-independent.
+                  ;; (substitute* "./icudefs.mk.in"
+                    ;; (("^CFLAGS = ")
+                     ;; "CFLAGS = -fPIC ")
+                    ;; (("^CXXFLAGS = ")
+                     ;; "CXXFLAGS = -fPIC "))
+                  ;; Update runpath.
+                  (substitute* "./icudefs.mk.in"
+                    (("= -L\\$\\(LIBDIR\\)")
+                     (string-append "= -L$(LIBDIR)"
+                                    " -Wl,-rpath=\"" #$output "/lib\"")))
+                  ;; Set prefix and exec-prefix.
+                  (substitute* "./runConfigureICU"
+                    (("^OPTS=")
+                     (string-append "OPTS=\""
+                                    (string-join configure-flags " ")
+                                    "\"")))
+                  ;; Configure.
+                  (invoke "./runConfigureICU" "Linux/gcc"
+                          "--disable-layout" "--disable-tests"))))
+            (add-after 'install 'configure-filtered-data
+              (lambda* (#:key make-flags configure-flags #:allow-other-keys)
+                ;; Cleanup.
+                (with-directory-excursion "data"
+                  `(,invoke "make" "clean" ,@make-flags))
+                ;; Set prefix and exec-prefix.
+                (substitute* "./runConfigureICU"
+                  (("^OPTS=")
+                   (string-append
+                    "OPTS=\"" (string-join configure-flags " ") "\"")))
+                ;; Configure for common data.
+                (setenv "ICU_DATA_FILTER_FILE"
+                        (string-append (getcwd) "/../filters/common.json"))
+                (invoke "./runConfigureICU" "Linux/gcc"
+                        "--disable-layout" "--disable-tests")))
+            (add-after 'configure-filtered-data 'build-filtered-data
+              (lambda* (#:key parallel-build? make-flags #:allow-other-keys)
+                (let ((job-count (if parallel-build?
+                                     (number->string (parallel-job-count))
+                                     "1")))
+                  `(,invoke "make" "-j" ,job-count ,@make-flags)
+                  (setenv "DESTDIR" #$output)
+                  (invoke "bash" "../scripts/copy_data.sh" "common"))))
+            (add-after 'build-filtered-data 'install-scripts-and-data
+              (lambda _
+                (let* ((share (string-append #$output "/share"))
+                       (scripts (string-append share "/scripts"))
+                       (data (string-append share "/data/common")))
+                  ;; Install scripts.
+                  (mkdir-p scripts)
+                  (copy-recursively "../scripts/" scripts)
+                  ;; Install data.
+                  (mkdir-p data)
+                  (copy-recursively "./dataout/common/data/out/tmp" data)
+                  (symlink (string-append data "/icudt69l.dat")
+                           (string-append data "/icudtl.dat")))))
+            (add-before 'check 'disable-failing-uconv-test
+              (lambda _
+                (substitute* "extra/uconv/Makefile.in"
+                  (("check: check-local")
+                   ""))))))))))